package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZOrder;
import cn.ibizlab.core.sample.filter.IBIZOrderSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZOrderMapper extends BaseMapper<IBIZOrder> {


    Page<IBIZOrder> searchCsdy(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listCsdy(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchCurState30(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listCurState30(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchDdjetjbb(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listDdjetjbb(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchDdReport(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listDdReport(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchDyddmxsjy(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listDyddmxsjy(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchDefault(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listDefault(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchEchartsDefaultDataSource(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listEchartsDefaultDataSource(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchGaugeDataSource(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listGaugeDataSource(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchGaugeDataSourceByTime(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listGaugeDataSourceByTime(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchLogic22(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listLogic22(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchRadarDataSource(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listRadarDataSource(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchShzOrder(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listShzOrder(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchState10(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listState10(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchState30(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listState30(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchState40(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listState40(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    Page<IBIZOrder> searchXecx(IPage page, @Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    List<IBIZOrder> listXecx(@Param("ctx") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);

    @Override
    IBIZOrder selectById(Serializable id);

    IBIZOrder selectEntity(IBIZOrder entity);

    List<IBIZOrder> selectEntities(@Param("list") List<IBIZOrder> list);

    @Override
    int insert(IBIZOrder entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZOrder entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZOrder entity, @Param("ew") Wrapper<IBIZOrder> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZOrder> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<IBIZOrder> selectByIbizCustomerId(@Param("ibizCustomerId") Serializable ibizCustomerId);

}